(function() {
  var crypt, exec, wrapStr, _;
  exec = require('child_process').exec;
  _ = require('underscore');
  wrapStr = function(str) {
    return '"' + str.replace(/\\/g, '\\\\').replace(/"/g, '\\"') + '"';
  };
  exports.listCiphers = function(callback) {
    var child;
    child = exec('openssl list-cipher-commands', function(err, stdout, stderr) {
      if (err != null) {
        return callback(err);
      } else {
        return callback(null, _.compact(stdout.split(/\s+/)));
      }
    });
  };
  crypt = function(cipher, value, key, callback, flags) {
    var child, _ref;
    if (callback == null) {
      _ref = [cipher, value, key], value = _ref[0], key = _ref[1], callback = _ref[2];
      cipher = 'aes-128-cbc';
    }
    if (!cipher.match(/^[a-z0-9-]+$/)) {
      throw new Error("Invalid cipher name: '" + cipher + "'");
    }
    value = wrapStr(value);
    key = wrapStr(key);
    child = exec("echo -n " + value + " | openssl " + cipher + " -k " + key + " " + flags, function(err, stdout, stderr) {
      if (err != null) {
        return callback(err);
      } else {
        return callback(null, stdout);
      }
    });
  };
  exports.encrypt = function(cipher, value, key, callback) {
    crypt(cipher, value, key, callback, '-e -base64');
  };
  exports.decrypt = function(cipher, value, key, callback) {
    crypt(cipher, value, key, callback, '-d -base64');
  };
  exports.toBase64 = function(str, callback) {
    var child;
    str = wrapStr(str);
    child = exec("echo -n " + str + " | openssl enc -base64", function(err, stdout, stderr) {
      if (err != null) {
        return callback(err);
      } else {
        return callback(null, stdout.replace(/\n^/, ''));
      }
    });
  };
  exports.fromBase64 = function(str, callback) {
    var child;
    str = wrapStr(str);
    child = exec("echo " + str + " | openssl enc -base64 -d", function(err, stdout, stderr) {
      if (err != null) {
        return callback(err);
      } else {
        return callback(null, stdout);
      }
    });
  };
}).call(this);
