(function() {
  var assert, cp, input, key, original, _;
  assert = require('assert');
  _ = require('underscore');
  cp = require('./cipherpipe');
  cp.listCiphers(function(err, ciphers) {
    assert.equal(err, null, '`openssl list-cipher-commands` should run without error');
    return assert.ok(_.include(ciphers, 'base64'), 'base64 should be available as a "cipher"');
  });
  original = 'foo';
  key = 'key';
  cp.encrypt(original, key, function(err, crypted) {
    assert.equal(err, null, '`openssl` should encrypt the string without error');
    return cp.decrypt(crypted, key, function(err, decrypted) {
      assert.equal(err, null, '`openssl` should decrypt the string without error');
      return assert.equal(decrypted, original, 'the decrypted string should match the original');
    });
  });
  input = 'bar';
  cp.toBase64(input, function(err, str64) {
    assert.equal(err, null, '`openssl` should encode to base64 without error');
    return cp.fromBase64(str64, function(err, str) {
      assert.equal(err, null, '`openssl` should decode base64 without error');
      return assert.equal(str, input, 'the decoded string should match the input');
    });
  });
}).call(this);
