{exec} = require 'child_process'
_ = require 'underscore'

wrapStr = (str) ->
  '"' +
  str.replace(/\\/g, '\\\\')
  .replace(/"/g, '\\"') +
  '"';

exports.listCiphers = (callback) ->
  child = exec 'openssl list-cipher-commands', (err, stdout, stderr) ->
    if err?
      callback err
    else
      callback null, _.compact(stdout.split /\s+/)
  return

crypt = (cipher, value, key, callback, flags) ->
  unless callback?
    [value, key, callback] = [cipher, value, key]
    cipher = 'aes-128-cbc'

  unless cipher.match /^[a-z0-9-]+$/
    throw new Error("Invalid cipher name: '#{cipher}'")

  value = wrapStr value
  key = wrapStr key

  child = exec "echo -n #{value} | openssl #{cipher} -k #{key} #{flags}", (err, stdout, stderr) ->
    if err?
      callback err
    else
      callback null, stdout
  return

exports.encrypt = (cipher, value, key, callback) ->
  crypt cipher, value, key, callback, '-e -base64'
  return

exports.decrypt = (cipher, value, key, callback) ->
  crypt cipher, value, key, callback, '-d -base64'
  return

exports.toBase64 = (str, callback) ->
  str = wrapStr str
  child = exec "echo -n #{str} | openssl enc -base64", (err, stdout, stderr) ->
    if err?
      callback err
    else
      callback null, stdout.replace /\n^/, '' # trim extra newline at the end
  return

exports.fromBase64 = (str, callback) ->
  str = wrapStr str
  child = exec "echo #{str} | openssl enc -base64 -d", (err, stdout, stderr) ->
    if err?
      callback err
    else
      callback null, stdout
  return