assert = require 'assert'
_ = require 'underscore'

cp = require './cipherpipe'

# Test cipher list
cp.listCiphers (err, ciphers) ->
  assert.equal err, null, '`openssl list-cipher-commands` should run without error'
  assert.ok _.include(ciphers, 'base64'), 'base64 should be available as a "cipher"'

# Test encrypt/decrypt
original = 'foo'
key = 'key'
cp.encrypt original, key, (err, crypted) ->
  assert.equal err, null, '`openssl` should encrypt the string without error'
  cp.decrypt crypted, key, (err, decrypted) ->
    assert.equal err, null, '`openssl` should decrypt the string without error'
    assert.equal decrypted, original, 'the decrypted string should match the original'

# Test base64 encode/decode
input = 'bar'
cp.toBase64 input, (err, str64) ->
  assert.equal err, null, '`openssl` should encode to base64 without error'
  cp.fromBase64 str64, (err, str) ->
    assert.equal err, null, '`openssl` should decode base64 without error'
    assert.equal str, input, 'the decoded string should match the input'